"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Users = exports.MyDateType = void 0;
const tslib_1 = require("tslib");
const core_1 = require("@mikro-orm/core");
const index_1 = require("./index");
class MyDateType extends core_1.Type {
}
exports.MyDateType = MyDateType;
let Users = class Users {
    constructor() {
        this.testReal = [];
        this.createdAt = new Date();
        this.updatedAt = new Date();
        this.roles = new core_1.Collection(this);
        this.comments = new core_1.Collection(this);
        this.notes = new core_1.Collection(this);
    }
};
exports.Users = Users;
tslib_1.__decorate([
    (0, core_1.PrimaryKey)({
        autoincrement: true,
    }),
    tslib_1.__metadata("design:type", Number)
], Users.prototype, "id", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        type: 'string',
        length: 100,
        unique: true,
    }),
    tslib_1.__metadata("design:type", String)
], Users.prototype, "login", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        name: 'first_name',
        type: 'varchar',
        length: 100,
        nullable: true,
    }),
    tslib_1.__metadata("design:type", String)
], Users.prototype, "firstName", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        name: 'test_real',
        type: new core_1.ArrayType((i) => parseFloat(i)),
        columnType: 'real[]',
        defaultRaw: `ARRAY[]::real[]`,
        default: [],
    }),
    tslib_1.__metadata("design:type", Array)
], Users.prototype, "testReal", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        name: 'test_array_null',
        type: new core_1.ArrayType((i) => parseFloat(i)),
        columnType: 'real[]',
        nullable: true,
    }),
    tslib_1.__metadata("design:type", Object)
], Users.prototype, "testArrayNull", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        name: 'last_name',
        type: 'string',
        columnType: 'varchar',
        length: 100,
        nullable: true,
    }),
    tslib_1.__metadata("design:type", String)
], Users.prototype, "lastName", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        name: 'is_active',
        type: 'boolean',
        nullable: true,
        default: false,
    }),
    tslib_1.__metadata("design:type", Boolean)
], Users.prototype, "isActive", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        name: 'test_date',
        type: Date,
        nullable: true,
        defaultRaw: 'CURRENT_TIMESTAMP(0)',
        columnType: 'timestamp(0) without time zone',
    }),
    tslib_1.__metadata("design:type", Date)
], Users.prototype, "testDate", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        length: 0,
        name: 'created_at',
        nullable: true,
        defaultRaw: 'CURRENT_TIMESTAMP(0)',
        columnType: 'timestamp(0) without time zone',
    }),
    tslib_1.__metadata("design:type", Date)
], Users.prototype, "createdAt", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        length: 0,
        onUpdate: () => new Date(),
        name: 'updated_at',
        nullable: true,
        columnType: 'timestamp(0) without time zone',
        defaultRaw: 'CURRENT_TIMESTAMP(0)',
    }),
    tslib_1.__metadata("design:type", Date)
], Users.prototype, "updatedAt", void 0);
tslib_1.__decorate([
    (0, core_1.OneToOne)(() => index_1.Addresses, {
        owner: true,
        fieldName: 'addresses_id',
        nullable: true,
    }),
    tslib_1.__metadata("design:type", Object)
], Users.prototype, "addresses", void 0);
tslib_1.__decorate([
    (0, core_1.OneToOne)(() => Users, {
        owner: true,
        nullable: true,
        fieldName: 'manager_id',
    }),
    tslib_1.__metadata("design:type", Object)
], Users.prototype, "manager", void 0);
tslib_1.__decorate([
    (0, core_1.ManyToMany)(() => index_1.Roles, (role) => role.users, {
        owner: true,
        pivotTable: 'users_have_roles',
        inverseJoinColumn: 'role_id',
        joinColumn: 'user_id',
    }),
    tslib_1.__metadata("design:type", Object)
], Users.prototype, "roles", void 0);
tslib_1.__decorate([
    (0, core_1.OneToMany)(() => index_1.Comments, (comment) => comment.createdBy),
    tslib_1.__metadata("design:type", Object)
], Users.prototype, "comments", void 0);
tslib_1.__decorate([
    (0, core_1.OneToMany)(() => index_1.Notes, (item) => item.createdBy),
    tslib_1.__metadata("design:type", Object)
], Users.prototype, "notes", void 0);
tslib_1.__decorate([
    (0, core_1.ManyToOne)(() => index_1.UserGroups, {
        fieldName: 'user_groups_id',
        nullable: true,
    }),
    tslib_1.__metadata("design:type", Object)
], Users.prototype, "userGroup", void 0);
exports.Users = Users = tslib_1.__decorate([
    (0, core_1.Entity)({
        tableName: 'users',
    })
], Users);
//# sourceMappingURL=users.js.map